﻿; **************************************************************
; ******* Počítadlo riadkov pre háčkovanie a pletenie **********
; **************************************************************
;    Filename: SDT Pocitadlo riadkov.bas
;    Date: 09.02.2015
;    File Version: 1.00
;    Written by: Róbert Šuška
;    Function: Počítadlo riadkov pre háčkovanie a pletenie mojej najdrahšej žene.
;    Last Revision: 02.03.2015 19:23 - FINAL CODE
;    Target PICAXE: 18M2

#picaxe 18M2

;#define LCD3902 ; po zruseni bodkociarky (cesky stredniku) na zaciatku riadku, zaisti prekladac preklad programu pre display s oznacenim LCD3902, inac bude program prelozeny pre display 4DR821B.

;#no_data ; po zruseni bodkociarky na zaciatku riadku, nedojde pri nahrani programu k premazaniu eeprom nulami v procesore.
eeprom 0, (0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0) ; inicializacia eeprom pri nahrani programu. pokial si neprajeme premazat eeprom pri dalsom programovani tento riadok zapoznamkujte a odpoznamkujte riadok #no_data

; pins ------------------------------------
symbol _data			=	C.1	; pin18
symbol _strob			=	C.0	; pin17
symbol _clk				=	C.7	; pin16
#ifdef LCD3902
symbol _showArrow			=	C.6	; pin15
#else
symbol _showTilde			=	C.6	; pin15
#endif
							; pin14 - + 5V
symbol _Volt			=	B.7	; pin13 ; - NC (Touch, In, Out)
#ifdef LCD3902
symbol _showTilde			=	B.6	; pin12
#else
symbol _showArrow			=	B.6	; pin12
#endif
							; pin11 - HW serial OUT (Touch, In, Out)
symbol _commAnode			=	B.4	; pin10							
symbol _buttonDown		=	B.3	; pin9
symbol _buttonUp			=	B.2	; pin8
symbol _buttonProgram		=	B.1	; pin7
symbol _showOneThousand		=	B.0	; pin6
							; pin5 - GND
							; pin4 - NC (In)
							; pin3 - PC (In)
							; pin2 - PC (Out)
symbol _buttonClean		=	C.2	; pin1
; -----------------------------------------


symbol eeProgramAddr		=	1

symbol minProgramValue		=	1
symbol maxProgramValue		=	10
symbol minProcessValue		=	0
symbol maxProcessValue		=	1999

symbol picStep2NextClick	=	8
symbol picStep2NextCleanClick	=	40
symbol hideArrowAfterStart	=	87
symbol timeToHideVoltValue	=	37
symbol timeToBlinkTidleLowBat	=	17

symbol charBlank			=	10
symbol charBrass			=	11

symbol memSendNum			=	$1C
symbol memProgramValue		=	$1D
symbol memProcessValue		=	$1E
symbol memVoltValue		=	$20

;symbol
symbol showDOT			=	bit0
symbol sendNegativ		=	bit1
symbol showOneThousand		=	bit2
symbol showArrow			=	bit3
symbol showTilde			=	bit4
symbol buttonSemaphore		=	bit5
symbol showArrowAfterStart	=	bit6
symbol showVolt			=	bit7
symbol pushCleanButton		=	bit8
symbol arrowShowed		=	bit9
symbol processValCleaned	=	bit10
symbol showBateryLow		=	bit11

symbol bPom1			=	b2
symbol bPom2			=	b3 ; w1
symbol bPom3			=	b4
symbol bPom4			=	b5 ; w2
symbol tisic			=	b6
symbol stovk			=	b7 ; w3
symbol desia			=	b8
symbol jedno			=	b9 ; w4
symbol bPom5			=	b10
symbol bPomButton			=	b11 ; w5
symbol bPom7			=	b12
symbol bPom8			=	b13 ; w6
symbol bPom9			=	b14
symbol bPom10			=	b15 ; w7

symbol wPom2			=	w12
symbol wPom1			=	w13

symbol __NULL			=	%11111111
symbol __0				=	%10001000
symbol __1				=	%11101110
symbol __2				=	%10010100
symbol __3				=	%11000100
symbol __4				=	%11100010
symbol __5				=	%11000001
symbol __6				=	%10000001
symbol __7				=	%11101100
symbol __8				=	%10000000
symbol __9				=	%11000000
symbol __Pom_11			=	%11110111

symbol bateryLOWValue		=	220 ; 2,20V - hodnota napatia od ktorej sa zacne signalizovat slaba bateria

init:
{
	setfreq M4

	disconnect
	disablebod
	disabletime

	pause 500

	fvrsetup FVR2048
	adcconfig %011

	bPom1 = 0
	read eeProgramAddr, bPom1
	poke memProgramValue, bPom1
	bPom1 = bPom1 * 2
	wPom1 = 0
	read bPom1, word wPom1
	poke memProcessValue, word wPom1

	low _commAnode
	low _showOneThousand
	low _showArrow
	low _showTilde

	showVolt = 0

	bPom10 = 0
	showBateryLow = 0

	processValCleaned = 0

	arrowShowed = 0

	bPom8 = 0
	showArrowAfterStart = 1

	pushCleanButton = 0
	bPom9 = 0

	buttonSemaphore = 1

	showOneThousand = 0
	if showArrowAfterStart = 1 then
		showArrow = 1
	else
		showArrow = 0
	endif

	setfreq M32
}


main:
{

	if showVolt = 0 and showBateryLow = 0 then

		readadc10 _Volt, wPom2

		wPom1 = wPom2 * 20
		wPom1 = wPom2 * 4 / 10 + wPom1
		wPom1 = wPom2 * 8 / 100 + wPom1
		wPom1 = wPom1 / 10
		; wPom1 = wPom1 + 1 ; tu sa da dotiahnut nepresnost odporoveho delica +1 pripocita 10mV

		poke memVoltValue, word wPom1
	endif

	peek memVoltValue, word wPom1

	if showBateryLow = 0 and wPom1 <= bateryLOWValue then

		showBateryLow = 1

	endif

	if showBateryLow = 1 then

		inc bPom10
		
		if bPom10 > timeToBlinkTidleLowBat then
		
			bPom10 = 0
			showTilde = not showTilde
			
		endif
	endif

	if showArrowAfterStart = 1 then

		inc bPom8

		if bPom8 > hideArrowAfterStart then

			showArrow = not showArrow
			showArrowAfterStart = 0
		endif
	endif

	if showVolt = 0 then

		if showArrow = 0 then

			peek memProcessValue, word wPom1
		else

			peek memProgramValue, wPom1
		endif
	endif

	bintoascii wPom1, bPom2, tisic, stovk, desia, jedno

	tisic = tisic - 48
	stovk = stovk - 48
	desia = desia - 48
	jedno = jedno - 48

	if tisic = 0 and stovk = 0 and desia = 0 then

		desia = charBlank
	endif

	if tisic = 0 and stovk = 0 then

		stovk = charBlank
	endif

	if tisic > 0 then

		showOneThousand = 1
	else

		showOneThousand = 0
	endif

	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, jedno
	endif
	gosub send2disp
	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, desia
	endif
	if showVolt = 1 then
		showDOT = 1
	endif
	gosub send2disp
	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, stovk
	endif

	gosub send2disp
	high _commAnode
	gosub showValue

	if showOneThousand = 0 then
		high _showOneThousand
	else
		low _showOneThousand
	endif

	if showArrow = 0 then
		high _showArrow
	else
		low _showArrow
	endif

	if showTilde = 0 then
		high _showTilde
	else
		low _showTilde
	endif	

	sendNegativ = 1
	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, jedno
	endif
	gosub send2disp
	sendNegativ = 1
	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, desia
	endif
	if showVolt = 1 then
		showDOT = 1
	endif
	gosub send2disp
	sendNegativ = 1
	if processValCleaned = 1 then
		poke memSendNum, charBrass
	else
		poke memSendNum, stovk
	endif
	gosub send2disp
	low _commAnode
	gosub showValue

	if showOneThousand = 0 then
		low _showOneThousand
	else
		high _showOneThousand
	endif

	if showArrow = 0 then
		low _showArrow
	else
		high _showArrow
	endif

	if showTilde = 0 then
		low _showTilde
	else
		high _showTilde
	endif	

	if buttonSemaphore = 1 then
		
		bPom7 = 0
		
		bPomButton = 0
		button _buttonClean, 1, 200, 100, bPomButton, 1, procClean
		bPomButton = 0
		button _buttonProgram, 1, 200, 100, bPomButton, 1, procProgram
		bPomButton = 0
		button _buttonUp, 1, 200, 100, bPomButton, 1, procUp
		bPomButton = 0
		button _buttonDown, 1, 200, 100, bPomButton, 1, procDown
	endif

	inc bPom7

	if buttonSemaphore = 0 and bPom7 > picStep2NextClick then

		buttonSemaphore = 1

	endif


	if pushCleanButton = 1 then

		inc bPom9

		if bPom9 > picStep2NextCleanClick then

			pushCleanButton = 0
			bPom9 = 0
			showVolt = 1
			#ifdef LCD3902
				;
			#else
			if showBateryLow = 0 then
				showTilde = 1
			endif
			#endif
			arrowShowed = 0
			if showArrow = 1 then
				arrowShowed = 1
				showArrow = 0
			endif
		endif
	endif

	if showVolt = 1 then

		inc bPom9

		if bPom9 > timeToHideVoltValue then

			bPom9 = 0
			showVolt = 0
			#ifdef LCD3902
				;
			#else
			if showBateryLow = 0 then
				showTilde = 0
			endif
			#endif
			if arrowShowed = 1 then
				showArrow = 1
			endif

		endif
	endif

	if processValCleaned = 1 then
		
		inc bPom9
		
		
		if bPom9 > 20 then
			
			bPom9 = 0
			processValCleaned = 0
		endif		
	endif

	goto main
}


;------------------------<  procClean >------------------------
procClean:
{
	buttonSemaphore = 0

	if bPom9 > 0 then

		processValCleaned = 1
		bPom9 = 0
		pushCleanButton = 0

		wPom2 = 0
		poke memProcessValue, word wPom2

	else

		bPom9 = 0
		pushCleanButton = 1
	endif

goto main
}


;-----------------------<  procProgram >-----------------------
procProgram:
{

	buttonSemaphore = 0

	showArrowAfterStart = 0

	showArrow = not showArrow

	bPom9 = 0
	pushCleanButton = 0

	peek memProcessValue, word wPom1
	peek memProgramValue, bPom1
	bPom1 = bPom1 * 2
	read bPom1, word wPom2

	if wPom1 = 0 and wPom1 != wPom2 then

		write bPom1, word wPom1
	endif

goto main
}


;--------------------------<  procUp >-------------------------
procUp:
{
	buttonSemaphore = 0

	bPom9 = 0
	pushCleanButton = 0

	if showArrow = 0 then

		peek memProcessValue, word wPom1
		inc wPom1

		if wPom1 > maxProcessValue then
			wPom1 = maxProcessValue
		endif

		poke memProcessValue, word wPom1

		read eeProgramAddr, bPom1
		bPom1 = bPom1 * 2
		write bPom1, word wPom1

	else
		showArrowAfterStart = 0

		peek memProgramValue, bPom1
		inc bPom1

		if bPom1 > maxProgramValue then
			bPom1 = maxProgramValue
		endif

		poke memProgramValue, bPom1
		write eeProgramAddr, bPom1

		bPom1 = bPom1 * 2
		read bPom1, word wPom1
		poke memProcessValue, word wPom1
	endif

goto main
}


;-------------------------<  procDown >------------------------
procDown:
{
	buttonSemaphore = 0

	bPom9 = 0
	pushCleanButton = 0

	if showArrow = 0 then

		peek memProcessValue, word wPom1

		if wPom1 > minProcessValue then
			dec wPom1
		endif

		poke memProcessValue, word wPom1

		read eeProgramAddr, bPom1
		bPom1 = bPom1 * 2
		write bPom1, word wPom1

	else

		showArrowAfterStart = 0

		peek memProgramValue, bPom1
		
		if bPom1 > minProgramValue then
			dec bPom1
		endif

		poke memProgramValue, bPom1
		write eeProgramAddr, bPom1

		bPom1 = bPom1 * 2
		read bPom1, word wPom1
		poke memProcessValue, word wPom1
	endif
	
goto main
}


;------------------------<  send2disp >------------------------
send2disp:
{
	peek memSendNum, bPom1
	select bPom1
	case 0
	   	bPom2 = __0
      case 1
         	bPom2 = __1
      case 2
         	bPom2 = __2
      case 3
         	bPom2 = __3
      case 4
         	bPom2 = __4
      case 5
         	bPom2 = __5
      case 6
         	bPom2 = __6
      case 7
         	bPom2 = __7
      case 8
         	bPom2 = __8
      case 9
         	bPom2 = __9
      case 10
         	bPom2 = __NULL
	case 11
		bPom2 = __Pom_11
     endselect

     if showDOT = 1 then
     		bPom2 = bPom2 & %01111111
     		showDOT = 0
     endif
     
     if sendNegativ = 1 then
		bPom2 = not bPom2
		sendNegativ = 0
     endif
     
     for bPom3 = 0 to 7
        bPom4 = bPom2 & %00000001
        
        if bPom4 = 1 then 
        	high _data
        else 
        	low _data
        endif
        
	  high _clk
        low _clk
        
        bPom2 = bPom2 / 2
     next bPom3

return
}


;------------------------<  showValue >------------------------
showValue:
{
     high _strob
     low _strob

return
}
